package abstractfactory;

public class Deportivo extends Vehiculo {
	private Chasis chasis;
	private Extras extras;
	private Motor motor;
	private Rueda ruedas;
	
	public Deportivo(FabricaComponentes fabricaComponentes) {
		ruedas = fabricaComponentes.creaRuedas();
		chasis = fabricaComponentes.creaChasis();
		motor = fabricaComponentes.creaMotor();
		extras = fabricaComponentes.creaExtras();
	}
	
	@Override
	public void descripcion() {
		System.out.println("--- Descripcin de un DEPORTIVO ---");
		ruedas.descripcion();
		chasis.descripcion();
		motor.descripcion();
		extras.descripcion();
		System.out.println("-----------------------------------");
	}

}
