package abstractfactory;

public class FabricaVehiculosJaponesa implements FabricaVehiculos {

	@Override
	public Vehiculo creaVehiculo(TipoVehiculo tipoVehiculo) {
		FabricaComponentes fabricaComponentes = new FabricaComponentesJaponesa();
		Vehiculo vehiculo;
		
		switch (tipoVehiculo) {
			case TURISMO:
				System.out.println("Fabricando un turismo japones...");
				vehiculo = new Turismo(fabricaComponentes);
				break;
				
			case BERLINA:
				System.out.println("Fabricando una berlina japonesa...");
				vehiculo = new Berlina(fabricaComponentes);
				break;
				
			case DEPORTIVO:
				System.out.println("Fabricando un deportivo japones...");
				vehiculo = new Deportivo(fabricaComponentes);
				break;

			default:
				System.out.println("Fabricando un turismo japones...");
				vehiculo = new Turismo(fabricaComponentes);
				break;
		}
		
		return vehiculo;
	}

}
