package tipos;

public class Persona implements Contacto {
	private String nombre;
	private String apellidos;
	private String telefono;
	private static int nInstancias;

	public Persona() {
		super();
		iniciaAtributos();
	}
	
	public static int getNInstancias() {
		return nInstancias;
	}

	protected void iniciaAtributos() {
		nombre = "";
		apellidos = "";
		telefono = "";
		nInstancias = 0;
	}

	public Persona(String nombre, String apellidos, String telefono) {
		super();
		this.nombre = nombre;
		this.apellidos = apellidos;
		this.telefono = telefono;
		nInstancias++;
	}
	
	@Override
	public String getNombre() {
		return nombre;
	}
	
	@Override
	public String getApellidos() {
		return apellidos;
	}
	
	@Override
	public String getTelefono() {
		return telefono;
	}

	public void setNombre(String nombre) {
		this.nombre = nombre;
	}

	public void setApellidos(String apellidos) {
		this.apellidos = apellidos;
	}

	public void setTelefono(String telefono) {
		this.telefono = telefono;
	}

	@Override
	public String toString() {
		return "Persona: " + nombre + ": " + apellidos + ": " + telefono;
	}
}
