package limite.superior;


import java.util.ArrayList;

import colecciones.figuras.Circulo;
import colecciones.figuras.Figura;
import colecciones.figuras.Rectangulo;
import colecciones.figuras.TrianguloRectangulo;

public final class Principal {
	private Principal() {
		super();
	}
	
	private void ejecuta() {
		// Una lista de figuras.
		ArrayList<Figura> figuras = new ArrayList<Figura>();
		// Crculos, tringulos rectngulos y rectngulos son figuras.
		figuras.add(new Circulo());
		figuras.add(new TrianguloRectangulo());
		figuras.add(new Rectangulo());
		// Ahora un ArrayList slo de crculos
		ArrayList<Circulo> circulos = new ArrayList<Circulo>();
		circulos.add(new Circulo(3));
		circulos.add(new Circulo(5));
//		figuras = circulos; // ERROR!!!
		// Una lista con lmite superior
		ArrayList<? extends Figura> figurasGeneral = circulos;
		ArrayList<Rectangulo> rectangulos = new ArrayList<Rectangulo>();
		rectangulos.add(new Rectangulo());
		rectangulos.add(new Rectangulo(1, 2));
		figurasGeneral = rectangulos;
		muestraAreas3(figurasGeneral);
		muestraAreas3(figuras);
		muestraAreas3(circulos);
		muestraAreas3(rectangulos);
	}
	
	private void muestraAreas(ArrayList<Figura> lista) {
		for(Figura elemento: lista) {
			System.out.println(elemento.getClass().getCanonicalName() + ": " + elemento.getArea());
		}
	}
	
	private <E extends Figura> void muestraAreas2(ArrayList<E> lista) {
		for(Figura elemento: lista) {
			System.out.println(elemento.getClass().getCanonicalName() + ": " + elemento.getArea());
		}
	}
	
	private void muestraAreas3(ArrayList<? extends Figura> lista) {
		for(Figura elemento: lista) {
			System.out.println(elemento.getClass().getCanonicalName() + ": " + elemento.getArea());
		}
	}	
	
	public static void main(String[] args) {
		new Principal().ejecuta();
	}
}
