package gui;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.SwingUtilities;

public final class EjemploJRadioButton {
	private EjemploJRadioButton() {
		super();
	}
	
	private JPanel creaContenedor(String posicion) {
		JPanel contenedor = new JPanel();
		contenedor.setLayout(new BoxLayout(contenedor, BoxLayout.Y_AXIS));
		Escuchador escuchador = new Escuchador();
		JRadioButton jrbMucho = new JRadioButton("Mucho");
		jrbMucho.addActionListener(escuchador);
		jrbMucho.addItemListener(escuchador);
		contenedor.add(jrbMucho);
		JRadioButton jrbNormal = new JRadioButton("Normal"); 
		jrbNormal.addActionListener(escuchador);
		jrbNormal.addItemListener(escuchador);
		contenedor.add(jrbNormal);
		JRadioButton jrbPoco = new JRadioButton("Poco"); 
		jrbPoco.addActionListener(escuchador);
		jrbPoco.addItemListener(escuchador);
		contenedor.add(jrbPoco);
		if(posicion == BorderLayout.EAST) {
			ButtonGroup grupo = new ButtonGroup();
			grupo.add(jrbMucho);
			grupo.add(jrbNormal);
			grupo.add(jrbPoco);
		}
		return contenedor;
	}

	private void creaGUI() {
		JFrame ventana = new JFrame("Ejemplo JRadioButton");
		ventana.add(creaContenedor(BorderLayout.WEST), BorderLayout.WEST);
		ventana.add(creaContenedor(BorderLayout.EAST), BorderLayout.EAST);
		ventana.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		ventana.pack();
		ventana.setVisible(true);
	}

	private class Escuchador implements ActionListener, ItemListener {
		public Escuchador() {
			super();
		}

		@Override
		public void actionPerformed(ActionEvent e) {
			System.out.println("Botn pulsado");
		}

		@Override
		public void itemStateChanged(ItemEvent e) {
			String texto = ((JRadioButton)e.getSource()).getText();
			if(e.getStateChange() == ItemEvent.DESELECTED)
				System.out.format("Botn %s deseleccionado.\n", texto);
			else if(e.getStateChange() == ItemEvent.SELECTED)
				System.out.format("Botn %s seleccionado.\n", texto);
		}		
	}

	public static void main(String[] args) {
		SwingUtilities.invokeLater(new Runnable() {			
			@Override
			public void run() {
				new EjemploJRadioButton().creaGUI();
			}
		});
	}

}
