package gui;

import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;

import javax.swing.JFrame;
import javax.swing.SwingUtilities;
// Esta clase implementa WindowListener luego es escuchador de WindowEvent
public class EjemploWindowListener implements WindowListener {
	private EjemploWindowListener() {
		super();
	}
	
	private void creaGUI() {
		// Creamos la ventana
		JFrame ventana = new JFrame("Aplicacin que se cierra con la ventan.");
		// Aadimos como escuchador la instancia de esta clase
		ventana.addWindowListener(this);
		ventana.setSize(400, 400);
		ventana.setVisible(true);		
	}
	
	public static void main(String[] args) {
		SwingUtilities.invokeLater(new Runnable() {			
			@Override
			public void run() {
				new EjemploWindowListener().creaGUI();
			}
		});
	}

	// Los mtodos que siguen estn declarados en la interface WindowListener
	@Override
	public void windowOpened(WindowEvent e) {
	}

	// Este es el nico mtodo con cdigo
	@Override
	public void windowClosing(WindowEvent e) {
		System.out.println("Cerrando la ventana...");
		System.exit(0);
	}

	@Override
	public void windowClosed(WindowEvent e) {
	}

	@Override
	public void windowIconified(WindowEvent e) {
	}

	@Override
	public void windowDeiconified(WindowEvent e) {
	}

	@Override
	public void windowActivated(WindowEvent e) {
	}

	@Override
	public void windowDeactivated(WindowEvent e) {
	}
}
