package gui.hipoteca.vista;

import gui.hipoteca.controlador.Controlador;
import gui.hipoteca.modelo.Modelo;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.lang.reflect.InvocationTargetException;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.SwingUtilities;

public class VistaImpl implements Vista {
	private Modelo modelo;
	private Controlador controlador;
	// Componentes grficos
	private Container contenedor;
	private JTextField jtfCantidad;
	private JTextField jtfTiempo;
	private JTextField jtfInteres;
	private JLabel jlCuota;

	public VistaImpl() {
		super();
		creaGUI();
	}

	private void creaGUI() {
		try {
			SwingUtilities.invokeAndWait(new Runnable() {			
				@Override
				public void run() {
					contenedor = new Container();
					contenedor.setLayout(new BorderLayout());
					JPanel jpDatos = new JPanel();
					jpDatos.add(new JLabel("Cantidad: "));
					jtfCantidad = new JTextField(8);
					jpDatos.add(jtfCantidad);
					jpDatos.add(new JLabel("Aos: "));
					jtfTiempo = new JTextField(3);
					jpDatos.add(jtfTiempo);
					jpDatos.add(new JLabel("Interes: "));
					jtfInteres = new JTextField(5);
					jpDatos.add(jtfInteres);
					JButton jbCalcula = new JButton("Calcula");
					jbCalcula.addActionListener(new Escuchador());
					jpDatos.add(jbCalcula);
					contenedor.add(jpDatos, BorderLayout.NORTH);
					jlCuota = new JLabel("Cuota mensual:");
					JPanel jpCuota = new JPanel();
					jpCuota.add(jlCuota);
					contenedor.add(jpCuota);
				}
			});
		} catch (InterruptedException e) {
			e.printStackTrace();
		} catch (InvocationTargetException e) {
			e.printStackTrace();
		}

		//		ventana.pack();
		//		ventana.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		//		ventana.setVisible(true);
	}

	@Override
	public Container getContenedor() {
		return contenedor;
	}

	@Override
	public void setModelo(Modelo modelo) {
		this.modelo = modelo;
	}

	@Override
	public void setControlador(Controlador controlador) {
		this.controlador = controlador;
	}

	private class Escuchador implements ActionListener {
		@Override
		public void actionPerformed(ActionEvent e) {
			controlador.solicitadoCalculo();
		}		
	}

	@Override
	public double getCantidad() {
		return Double.parseDouble(jtfCantidad.getText());
	}

	@Override
	public int getTiempo() {
		return Integer.parseInt(jtfTiempo.getText());
	}

	@Override
	public double getInteres() {
		return Double.parseDouble(jtfInteres.getText());
	}

	@Override
	public void cuotaActualizada() {
		String cuota = String.format("Cuota mensual: %.2f", modelo.getCuota());
		jlCuota.setText(cuota);
	}
}
