package buffer;

import java.util.concurrent.locks.Condition;
import java.util.concurrent.locks.Lock;
import java.util.concurrent.locks.ReentrantLock;

public class BufferConLock<T> {
	private int cabeza = 0;
	private int capacidad;
	private Object datos[];
	private int ocupacion = 0;
	private Lock cerrojo;
	private Condition condicion;

	public BufferConLock(int capacidad) {
		super();
		this.capacidad = capacidad;
		datos = new Object[capacidad];
		cerrojo = new ReentrantLock();
		condicion = cerrojo.newCondition();
	}

	@SuppressWarnings("unchecked")
	public T getDato() throws InterruptedException {
		T dato;
		cerrojo.lock();
		try {
			while(ocupacion == 0)
				condicion.await();
			dato = (T)datos[cabeza];
			ocupacion--;
			cabeza++;
			cabeza %= capacidad;
			System.out.format("-%s[%d]\n", dato, ocupacion);
		} finally {
			condicion.signalAll();
			cerrojo.unlock();
		}
		return dato;
	}

	public void setDato(T dato) throws InterruptedException {
		cerrojo.lock();
		try {
			while(ocupacion == capacidad)
				condicion.await();
			datos[(cabeza + ocupacion)%capacidad] = dato;
			ocupacion++;
			System.out.format("+%s[%d]\n", dato, ocupacion);
		} finally {
			condicion.signalAll();
			cerrojo.unlock();
		}
	}
}
