package estructuras;


public class BufferSinLock<T> implements Buffer<T> {
	private int cabeza = 0;
	private int capacidad;
	private Object datos[];
	private int ocupacion = 0;

	public BufferSinLock(int capacidad) {
		super();
		this.capacidad = capacidad;
		datos = new Object[capacidad];
	}

	@Override
	@SuppressWarnings("unchecked")
	public synchronized T getDato(String cliente) throws InterruptedException {
		T dato;
			while(ocupacion == 0)
				wait();
			dato = (T)datos[cabeza];
			ocupacion--;
			cabeza++;
			cabeza %= capacidad;
			System.out.format("-%s(%s)[%d]\n", dato, cliente, ocupacion);
		return dato;
	}

	@Override
	public synchronized void setDato(T dato) throws InterruptedException {
			while(ocupacion == capacidad)
				wait();
			datos[(cabeza + ocupacion)%capacidad] = dato;
			ocupacion++;
			System.out.format("+%s[%d]\n", dato, ocupacion);
	}
}