package hilos;

public final class EjemploJoin {
	private Thread hilo;

	private EjemploJoin() {
		super();
	}

	private void ejecuta() {
		hilo = new Thread(new Tarea());
		hilo.start();
		new Thread(new TareaQueEspera()).start();
	}

	private class Tarea implements Runnable {
		public void run() {
			try {
				for(int i = 0; i < 10; i++) {
					System.out.println("Cuenta: " + i);
					Thread.sleep(500);
				}
			} catch(InterruptedException e) {
				e.printStackTrace();
			}
		}		
	}

	private class TareaQueEspera implements Runnable {
		public void run() {
			try {
				for(int i = 0; i < 5; i++) {
					System.out.println("Cuenta y espera: " + i);
					Thread.sleep(500);
				}

				hilo.join();

				for(int i = 5; i < 10; i++) {
					System.out.println("Salgo de la espera y cuenta: " + i);
					Thread.sleep(500);
				}
			} catch(InterruptedException e) {
				e.printStackTrace();
			}
		}		
	}

	public static void main(String[] args) {
		new EjemploJoin().ejecuta();
	}
}
