package red;

import java.io.BufferedReader;
import java.io.IOException;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.List;
import java.util.Map;
import java.util.Set;

public final class Cabeceras {
	private Cabeceras() {
		super();
	}

	private void ejecuta(String direccion) {
		try {
			URL url;
			HttpURLConnection http = null;
			BufferedReader br = null;
			try {
				url = new URL(direccion);
				http = (HttpURLConnection)url.openConnection();
				Map<String, List<String>> cabeceras = http.getHeaderFields();
				Set<String> claves = cabeceras.keySet();
				List<String> valores;
				for(String clave: claves) {
					valores = cabeceras.get(clave);
					for(String valor: valores)
						System.out.println(clave + " --> " + valor + "; ");
				}
			} finally {
				if(br != null) br.close();
				if(http != null) http.disconnect();
			}
		} catch (MalformedURLException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public static void main(String[] args) {
		new Cabeceras().ejecuta(args[0]);
	}
}
