package strategy.tipos.cultural;

import strategy.tipos.Agenda;
import strategy.tipos.Item;

public final class AgendaCultural extends Agenda<TipoEvento> {

	@Override
	public Item getItem(TipoEvento tipo) {
		switch(tipo) {
			case CONFERENCIA:
				return new Conferencia();
			case CHARLA:
				return new Charla(new LectorCharlaTeclado(),
								  new EscritorCharlaConsola());
			case PROYECCION:
				return new Proyeccion();
			case TEATRO:
				return new Teatro();
		}
		return null;
	}

}
