package strategy.tipos.telefonica;

import strategy.tipos.Item;
import strategy.tipos.io.Escritor;
import strategy.tipos.io.Lector;

public class Persona extends Item {
	private String nombre;
	private String apellidos;
	private String telefono;
	private Lector<Persona> lector;
	private Escritor<Persona> escritor;

	public Persona() {
		super();
	}
	
	public Persona(Lector<Persona> lector, Escritor<Persona> escritor) {
		super();
		this.lector = lector;
		this.escritor = escritor;
	}

	public void setLector(Lector<Persona> lector) {
		this.lector = lector;
	}

	public void setEscritor(Escritor<Persona> escritor) {
		this.escritor = escritor;
	}

	public String getNombre() {
		return nombre;
	}

	public void setNombre(String nombre) {
		this.nombre = nombre;
	}

	public String getApellidos() {
		return apellidos;
	}

	public void setApellidos(String apellidos) {
		this.apellidos = apellidos;
	}

	public String getTelefono() {
		return telefono;
	}

	public void setTelefono(String telefono) {
		this.telefono = telefono;
	}

	@Override
	public void mostrarDatos() {
		escritor.escribeDatos(this);
	}

	@Override
	public void pedirDatos() {
		lector.leeDatos(this);
	}
}
