package test;

import org.junit.Test;
import static org.junit.Assert.*;

import conversor.ConversorTemperaturas;
import conversor.TemperaturaNoValidaException;

public class TestConversorTemperaturas {

	@Test
	public void testCelsiusAFharenheit() throws TemperaturaNoValidaException {
		ConversorTemperaturas conversor = new ConversorTemperaturas();
		assertEquals(32, conversor.celsiusAFharenheit(0), 0);
	}

	@Test
	public void testCelsiusAReamur() throws TemperaturaNoValidaException {
		ConversorTemperaturas conversor = new ConversorTemperaturas();
		assertEquals(0, conversor.celsiusAReamur(0), 0);
	}

	@Test(expected=TemperaturaNoValidaException.class)
	public void testTemperaturaNoValidaFharenheit() throws TemperaturaNoValidaException {
		ConversorTemperaturas conversor = new ConversorTemperaturas();
		conversor.celsiusAFharenheit(-400);
	}

	@Test
	public void testTemperaturaNoValidadFahrenheit() {
		ConversorTemperaturas conversor = new ConversorTemperaturas();
		try {
			conversor.celsiusAFharenheit(-400);
			fail("Para temperaturas por encima de -273 la prueba debe pasar.");
		} catch (TemperaturaNoValidaException e) {
		}
	}
}
