package test;

import static org.junit.Assert.*;

import java.util.Arrays;
import java.util.Collection;

import org.junit.AfterClass;
import org.junit.BeforeClass;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.junit.runners.Parameterized;
import org.junit.runners.Parameterized.Parameters;

import conversor.ConversorTemperaturas;
import conversor.TemperaturaNoValidaException;

@RunWith(Parameterized.class) 
public class TestConversorTemperaturas4 {
	private double celsius; 
	private double fharenheit; 
	private double reamur; 
	private double error;
	private static ConversorTemperaturas conversor;

	public TestConversorTemperaturas4(double celsius, double fharenheit, double reamur, double error) { 
		this.celsius = celsius; 
		this.fharenheit = fharenheit; 
		this.reamur = reamur;
		this.error = error;
	}

	@Parameters
	public static Collection<Object[]> datos() { 
		return Arrays.asList(new Object[][]{
				{0.0, 32.0, 0.0, 0.0}, // {celsius, fharenheit, reamur, error} 
				{15, 59.0, 12.0, 0.0}, 
				{30, 86.0, 24.0, 0.0}, 
				{50, 122.0, 40.0, 0.0},
				{90, 194.0, 72.0, 0.0} 
		});
	}
	
	@BeforeClass
	public static void iniciaConversor() {
		conversor = new ConversorTemperaturas();
	}
	
	@AfterClass
	public static void eliminaConversor() {
		conversor = null;
	}

	@Test
	public void testCelsiusAFharenheit() throws TemperaturaNoValidaException {
		assertEquals(fharenheit, conversor.celsiusAFharenheit(celsius), error);
	}

	@Test
	public void testCelsiusAReamur() throws TemperaturaNoValidaException {
		assertEquals(reamur, conversor.celsiusAReamur(celsius), error);
	}
}
